
%Compute the signature score and variance explained 

load('fmridata1cnew.mat')   %load the sample
load('mask.mat')
load('MaskM.mat')   %load the eigenfunctions
[s L]= size(M);
lim = 1360;
newmask = mask(:,9:100,11:81); % fits the mask on the cutted data
[I1 I2 I3] = size(newmask); %size(mask.img)
[i1, lin] = find(newmask==0);  % find where is the mask equal zero
[i2, i3] = ind2sub([I2,I3],lin);  % lin gives only the linear indices, transform into arrays indices

voli=temp(:,9:100,11:81);
clear temp




for t=1:lim
     for k3=1:i3
         for k2=1:i2
         voli(i1,k2,k3,t) = 0;
         end
     end
end
   
 [J1 J2 J3 T]=size(voli);
    
    
 Y = voli;
 [G1 G2 G3 T] = size(Y);
 
 zhats = zeros(T,L-1);    % L is number of EFs
 
 regr = [reshape(M(2).m,G1*G2*G3,1) reshape(M(3).m,G1*G2*G3,1) reshape(M(4).m,G1*G2*G3,1) reshape(M(5).m,G1*G2*G3,1) reshape(M(6).m,G1*G2*G3,1) reshape(M(7).m,G1*G2*G3,1) reshape(M(8).m,G1*G2*G3,1) reshape(M(9).m,G1*G2*G3,1) reshape(M(10).m,G1*G2*G3,1) reshape(M(11).m,G1*G2*G3,1) reshape(M(12).m,G1*G2*G3,1) reshape(M(13).m,G1*G2*G3,1) reshape(M(14).m,G1*G2*G3,1) reshape(M(15).m,G1*G2*G3,1) reshape(M(16).m,G1*G2*G3,1) reshape(M(17).m,G1*G2*G3,1) reshape(M(18).m,G1*G2*G3,1) reshape(M(19).m,G1*G2*G3,1) reshape(M(20).m,G1*G2*G3,1) reshape(M(21).m,G1*G2*G3,1)];

Y=de_mean(Y); 
 
matlabpool close force
matlabpool open
 parfor i=1:T
     i
        dep=reshape(Y(:,:,:,i),G1*G2*G3,1);
        b=regress(dep,regr);
        zhats(i,:) = b';
 end
 matlabpool close
 save('path1.mat','zhats')
 
 %%%%%%%%%%%%%%%%%%%%%%RV
 %RV=0;RV1=0;RV2=0;RV3=0;RV4=0;RV6=0;RV7=0;
 YM = mean(mean(mean(mean(Y))));
 l = length(zhats);
 zhat = [ones(l,1) zhats];
    up = 0;
    up1 = 0;
    up2 = 0;
    up3 = 0;
    up4 = 0;
    up5 = 0;
    up6 = 0;
    up7 = 0;
    lw = 0;
    for i=1:lim%1360
        Yhat =M(1).m+ M(2).m*zhat(i,2)+ M(3).m*zhat(i,3)+ M(4).m*zhat(i,4)+ M(5).m*zhat(i,5)+ M(6).m*zhat(i,6)+ M(7).m*zhat(i,7)+ M(8).m*zhat(i,8)+M(9).m*zhat(i,9)+M(10).m*zhat(i,10)+M(11).m*zhat(i,11)+M(12).m*zhat(i,12)+ M(13).m*zhat(i,13)+ M(14).m*zhat(i,14)+ M(15).m*zhat(i,15)+ M(16).m*zhat(i,16)+ M(17).m*zhat(i,17)+ M(18).m*zhat(i,18)+M(19).m*zhat(i,19)+M(20).m*zhat(i,20)+M(21).m*zhat(i,21);
        diff=(Y(:,:,:,i)-Yhat).^2 ;    
        up = up+sum(sum(sum(diff)));
        lw = lw + sum(sum(sum((Y(:,:,:,i)-YM).^2)));
        %
        Yhat1 =M(1).m;
        diff1=(Y(:,:,:,i)-Yhat1).^2 ;    
        up1 = up1+sum(sum(sum(diff1)));
        %
        Yhat2 =M(1).m+M(2).m*zhat(i,2);
        diff2=(Y(:,:,:,i)-Yhat2).^2 ;    
        up2 = up2+sum(sum(sum(diff2)));
        %
        Yhat3 =M(1).m+ M(2).m*zhat(i,2)+ M(3).m*zhat(i,3);
        diff3=(Y(:,:,:,i)-Yhat3).^2 ;    
        up3 = up3+sum(sum(sum(diff3)));
        %
        Yhat4 =M(1).m+ M(2).m*zhat(i,2)+ M(3).m*zhat(i,3)+ M(4).m*zhat(i,4);
        diff4=(Y(:,:,:,i)-Yhat4).^2 ;    
        up4 = up4+sum(sum(sum(diff4)));
         
         Yhat5 =M(1).m+ M(2).m*zhat(i,2)+ M(3).m*zhat(i,3)+ M(4).m*zhat(i,4)+ M(5).m*zhat(i,5);
         diff5=(Y(:,:,:,i)-Yhat5).^2 ;    
         up5 = up5+sum(sum(sum(diff5)));
        %
        Yhat6 =M(1).m+ M(2).m*zhat(i,2)+ M(3).m*zhat(i,3)+ M(4).m*zhat(i,4)+ M(5).m*zhat(i,5)+ M(6).m*zhat(i,6);
        diff6=(Y(:,:,:,i)-Yhat6).^2 ;    
        up6 = up6+sum(sum(sum(diff6)));
        %
        Yhat7 =M(1).m+ M(2).m*zhat(i,2)+ M(3).m*zhat(i,3)+ M(4).m*zhat(i,4)+ M(5).m*zhat(i,5)+ M(6).m*zhat(i,6)+ M(7).m*zhat(i,7);
        diff7=(Y(:,:,:,i)-Yhat7).^2 ;    
        up7 = up7+sum(sum(sum(diff7)));
        
    end
    RV=up/lw;
    RV1=up1/lw;
    RV2=up2/lw;
    RV3=up3/lw;
    RV4=up4/lw;
    RV5=up5/lw;
    RV6=up6/lw;
    RV7=up7/lw;
    
    
    save('RVsubject1.mat','RV','RV1','RV2','RV3','RV4','RV5','RV6','RV7')
    

 
 
 
 
 
 
 
 